angular.module('starter.controllers', [])




.controller('HomeCtrl', function($scope, $state, $localStorage, $cordovaVibration, $timeout) {
  $scope.switch = function(muster){
    $state.go('tab.muster');
    $localStorage.marker = 1;
    delete $localStorage.currMaxMarker;
    $localStorage.svg = muster;
  };

  /*
  Hier kommt die Validierung der App rein!
   */
  $scope.active = $localStorage.activated;
  $scope.activate = function(code){
    console.log("Das steht in der Form: " + code);
    if(code === "WOLLSUECHTIG"){
      $timeout(function(){
        $scope.$apply(function(){
          $localStorage.activated = true;
          $scope.active = $localStorage.activated;
          $cordovaVibration.vibrate(50);
        });
      }, 1000);
    } else {
      alert("Falsches Passwort!");
    }
  };

})




.controller('QrCtrl', function($scope, $state, $rootScope, $ionicPlatform, $cordovaVibration, $localStorage,$ionicPlatform, $cordovaBarcodeScanner) {
  //$scope.$on('$ionicView.enter', function(e) {
 var vm = this;

 vm.scan = function(){
          $ionicPlatform.ready(function() {
              $cordovaBarcodeScanner
                  .scan()
                  .then(function(result) {
                   switch(result.text) {

                     case "001":
                       console.log("001");
                       $state.go('tab.handschmeichler');
                       break;
                       case "002":
                         console.log("002");
                         $state.go('tab.wonneproppen');
                         break;
                       case "003":
                         console.log("003");
                         $state.go('tab.blumenfee');
                         break;
                       case "004":
                         console.log("004");
                         $state.go('tab.primel');
                         break;
                                 case "005":
                         console.log("005");
                         $state.go('tab.almrausch');
                         break;
                                 case "006":
                         console.log("006");
                         $state.go('tab.sternschnupperl');
                         break;
                                 case "007":
                         console.log("007");
                         $state.go('tab.bergsteiger');
                         break;
                                 case "008":
                         console.log("008");
                         $state.go('tab.bellaluna');
                         break;
                                 case "009":
                         console.log("009");
                         $state.go('tab.farbensammler');
                         break;
                                 case "010":
                         console.log("010");
                         $state.go('tab.buntemeute');
                         break;
                                 case "011":
                         console.log("011");
                         $state.go('tab.herbstradler');
                         break;
                                 case "012":
                         console.log("012");
                         $state.go('tab.romantiker');
                         break;
                                 case "013":
                         console.log("013");
                         $state.go('tab.wilderstrampler');
                         break;
                                 case "014":
                         console.log("004");
                         $state.go('tab.sachensucher');
                         break;
                                 case "015":
                         console.log("004");
                         $state.go('tab.gipfelstuermer');
                         break;
                                 case "016":
                         console.log("016");
                         $state.go('tab.skipionier');
                         break;
                                 case "017":
                         console.log("017");
                         $state.go('tab.rodlkoenig');
                         break;

                                       case "018":
                         console.log("018");
                         $state.go('tab.strawanzer');
                         break;


       }






                  }, function(error) {
                      // An error occurred
                      vm.scanResults = 'Error: ' + error;
                  });
          });
      };
     vm.scanResults = '';


})



.controller('InfoCtrl', function($scope, $state) {

})

.controller('FruehlingCtrl', function($scope, $state) {

})


.controller('MusterCtrl', function($scope, $localStorage, $cordovaVibration) {
  console.log("controller called");

  var s = Snap("#svg");
  Snap.load("svgs/"+ $localStorage.svg +".svg", function(data){
    s.style.zIndex = "1";
    s.append(data);
    s.select("#m_" + $localStorage.marker).addClass("marked").addClass("fixed");
  });

  $scope.$on('$ionicView.enter', function(e){
    console.log("View geentert!");
    s.select("#m_" + $localStorage.marker).addClass("marked").addClass("fixed");
  });

  $scope.$watch(function(){ return $localStorage.svg;},
                function(newVal, oldVal){
                  s.clear();
                  Snap.load("svgs/" + newVal + ".svg", function(data){
                    s.append(data);
                    s.select("#m_" + $localStorage.marker).addClass("marked").addClass("fixed");
                  });
                }
  );
  $scope.$watch(function(){ return $localStorage.marker;},
                function(newVal, oldVal){
                  console.log("newVal", newVal);
                  s.select("#m_" + oldVal).removeClass("marked");
                  s.select("#m_" + newVal).addClass("marked").addClass("fixed");
                  console.log("oldVal", oldVal);
                }
              );


/*

















 */
  $scope.up = function(){
    var currentMarkedEle = document.getElementById("m_" + ($localStorage.marker + 1));
    if(currentMarkedEle === null){
      $localStorage.currMaxMarker = $localStorage.marker;
      $localStorage.marker = 1;
    } else {
      $localStorage.marker++;
    }
  };

  /*
Falls ich bei der untersten Linie zurück will, komme ich wieder an die oberste Linie.
Das geht erst sobald ich einmal durchgelaufen bin, da ich erst dan weiss, wie viele
Reihen ich habe.
   */
  $scope.down = function(){
    $cordovaVibration.vibrate(50);
    var currentMarkedEle = document.getElementById("m_" + ($localStorage.marker - 1));
    if(currentMarkedEle === null){
      $localStorage.marker = $localStorage.currMaxMarker;
    } else {
      $localStorage.marker--;
    }
  };

  /*
  Dimensionen für das Scroll Element
   */
  getHeight = function(){
   var navbarHeight = document.getElementsByTagName('ion-header-bar')[0].clientHeight;
   var tabHeight = document.getElementsByClassName('tab-nav tabs')[0].clientHeight;
   return parseInt(window.innerHeight - navbarHeight - tabHeight) + 'px';
 };

  getWidth = function(){
   return window.innerWidth + 'px';
 };

  $scope.style = { height: getHeight(), width: getWidth()};
});
